% Fourier-sorfejtes demo
% Budai Tams, Unger Tams
% 2012

%under warningot kapcsoljuk ki
%#ok<*DEFNU>

function varargout = fourier_gui(varargin)

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @fourier_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @fourier_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before fourier_gui is made visible.
function fourier_gui_OpeningFcn(hObject, ~, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to fourier_gui (see VARARGIN)
axes(handles.logobox);
imshow('feladat.jpg');

T=10;
handles.n = 10;
handles.r = 1;
handles.c = 5;

handles.omega = (2*pi) / (T);
t = linspace(0,20,2000);
handles.t = t;
handles.s = 5 * (heaviside(t-(0.25*T)) - heaviside(t-T) + heaviside(t-(1.25*T)) - heaviside(t-(2*T)));

axes(handles.axes1);
data = calculate(handles.n,handles.t,handles.omega,handles.r,handles.c);
hold all;
plot(handles.t,handles.s,'k');
plot(t,data.st_f,'b');
plot(t,data.yt_f,'r');
legend(handles.axes1, 'show','s(t)','s(t) Fourier kz.','y(t) Fourier kz.');


% tegyuk az ablakot a kepernyo kozepere
movegui(hObject,'center');
% Choose default command line output for fourier_gui
handles.output = hObject;

% update_gui handles structure
guidata(hObject, handles);

% UIWAIT makes fourier_gui wait for user response (see UIRESUME)
% uiwait(handles.gui);


% --- Outputs from this function are returned to the command line.
function varargout = fourier_gui_OutputFcn(~, ~, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in update_gui.
function update_gui_Callback(~, ~, handles) 
% hObject    handle to update_gui (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.n_gui = str2double(get(handles.n_gui,'String'));
handles.r_gui = str2double(get(handles.r_gui,'String'));
handles.c_gui = str2double(get(handles.c_gui,'String'));

data=calculate(handles.n_gui,handles.t,handles.omega,handles.r_gui,handles.c_gui);
axes(handles.axes1);
cla(handles.axes1);
hold all;
plot(handles.t,handles.s,'k');
plot(handles.t,data.st_f,'b');
plot(handles.t,data.yt_f,'r');
legend(handles.axes1, 'show','s(t)','s(t) Fourier kz.','y(t) Fourier kz.');


function r_gui_Callback(hObject, ~, handles)
% hObject    handle to r_gui (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of r_gui as text
%        str2double(get(hObject,'String')) returns contents of r_gui as a double
handles.r = str2double(get(hObject,'String'));

% --- Executes during object creation, after setting all properties.
function r_gui_CreateFcn(hObject, ~, ~)
% hObject    handle to r_gui (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function c_gui_Callback(hObject, ~, handles)
% hObject    handle to c_gui (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of c_gui as text
%        str2double(get(hObject,'String')) returns contents of c_gui as a double
handles.c = str2double(get(hObject,'String'));

% --- Executes during object creation, after setting all properties.
function c_gui_CreateFcn(hObject, ~, ~)
% hObject    handle to c_gui (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function n_gui_Callback(hObject, ~, handles)
% hObject    handle to n_gui (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of n_gui as text
%        str2double(get(hObject,'String')) returns contents of n_gui as a double
handles.n = str2double(get(hObject,'String'));

% --- Executes during object creation, after setting all properties.
function n_gui_CreateFcn(hObject, ~, ~)
% hObject    handle to n_gui (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% ---------------------------------------------------------
% a fuggveny ami kiszamolja a sorfejtest
function data = calculate(n,t,omega,R,C)

%S0 DC-komponens elre definilsa
S0 = 3.75;

% SkA s SkB elre lefoglalsa (optimalizci)
SkA = zeros(1,n);
SkB = zeros(1,n);
% A for iterci kvetkezik, ahol k a futvltoz
for k = 1:n,
    SkA(1,k) = (10 / (k*2*pi)) * ( (sin(k*2*pi)) - (sin(k*(pi/2))));
    SkB(1,k) = (-10 / (k*2*pi)) * ( (cos(k*2*pi)) - (cos(k*(pi/2))));
end;

%Sk komplex vektorok hosszainak szmtsa
Sk_length = zeros(1,k);
for k = 1:n,
    Sk_length(1,k) = sqrt((SkA(1,k)^2) + (SkB(1,k)^2));
end;

%Sk komplex vektorok szgeinek szmtsa
Sk_phase = zeros(1,k);
for k = 1:n,
    Sk_phase(1,k) = -atan2( (SkB(1,k)) , (SkA(1,k)) );
end;

%tviteli fggvny
Wk=zeros(1,k);
for k = 1:n,
    Wk(1,k) = ((k*omega*R*C)*1i) / (1+((k*omega*R*C)*1i));
end;

Wkreal=zeros(1,k);
Wkimag=zeros(1,k);
phaseWk=zeros(1,k);
Wkabs=zeros(1,k);
for k = 1:n,
    Wkreal(1,k) = real(Wk(1,k));
    Wkimag(1,k) = imag(Wk(1,k));
    phaseWk(1,k) = atan2( Wkimag(1,k) , Wkreal(1,k));
    Wkabs(1,k) = abs(Wk(1,k));
end;


% a gerjeszts egyes komponenseinek kiszmtsa
sc = zeros(k,size(t,2));
for k =1:n,
    a = Sk_length(1,k)*cos(k*omega*t+Sk_phase(1,k));
    sc(k,:) = a;
end;

%A vlaszjel komponenseinek kiszmtsa
yc = zeros(k, size(t,2));
for k =1:n,
    b = ((Sk_length(1,k)) * (Wkabs(1,k))) * cos(k*omega*t + ((Sk_phase(1,k)) + (phaseWk(1,k))));
    yc(k,:) = b;
end

% a gerjeszts komponenseinek sszegzse
st_f = S0;
for k=1:n       
    st_f=st_f+sc(k,:);
end;

%A vlaszjel komponenseinek sszegzse
yt_f = 0;
for k=1:n,
    yt_f = yt_f+yc(k,:);
end;

data.st_f = st_f;
data.yt_f = yt_f;
% ------------------------------------------------------------


% --- Executes during object creation, after setting all properties.
function axes1_CreateFcn(~, ~, ~)
% hObject    handle to axes1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes1
